#include "../utils.h"
#include "../factory_objects.h"
#include "../resources.h"
#include "../camera.h"
#include "../player.h"

typedef struct actor_diamond_s
{
    object_t *self_object;
    sprite_t *sprite;
    vector_t  position;
} actor_diamond_t;

static void _Actor_Diamond_CreateAnimations(actor_diamond_t *actor)
{
    Sprite_AnimationAdd(actor->sprite, "idle", 8);
    Sprite_AnimationAddFrame(actor->sprite, "idle", Utils_GetRect(0, 0, 9, 8));
}

static void _Actor_Diamond_GetInfo(actor_diamond_t *actor, object_info_t *info)
{
    if (actor == NULL)
        return;

    if (info == NULL)
        return;

    info->box_rect       = Utils_GetRect(0, 0, 0, 0);
    info->collision_rect = Utils_GetRect(0, 0, 0, 0);
    info->position       = actor->position;

    if (actor->sprite != NULL)
    {
        info->box_rect.x = actor->position.x - actor->sprite->origin.x;
        info->box_rect.y = actor->position.y - actor->sprite->origin.y;
        info->box_rect.w = actor->sprite->width;
        info->box_rect.h = actor->sprite->height;

        info->collision_rect.x = actor->position.x - (actor->sprite->width / 2);
        info->collision_rect.y = actor->position.y - (actor->sprite->height / 2);
        info->collision_rect.w = actor->sprite->width;
        info->collision_rect.h = actor->sprite->height;
    }

    info->collision_cell_ul = Utils_GetPoint(0, 0);
    info->collision_cell_br = Utils_GetPoint(0, 0);
}

static void _Actor_Diamond_Collision(actor_diamond_t *actor, void *actor_collision, actor_type_t actor_type)
{
    if (actor == NULL)
        return;

    if (actor_type == AT_ROBO)
    {
        Player_IncDiamond();

        Camera_PlaySound(bonusSnd, actor->position);
        FactoryObjects_SignRemove(actor->self_object);
    }
}

static void _Actor_Diamond_Update(actor_diamond_t *actor, float dt)
{
    if (actor == NULL)
        return;

    Sprite_Update(actor->sprite);
}

static void _Actor_Diamond_Draw(SDL_Renderer *renderer, actor_diamond_t *actor)
{
    if (actor == NULL)
        return;

    if (actor->sprite != NULL)
    {
        Sprite_Draw(renderer, actor->sprite, actor->position);
    }
}

static void _Actor_Diamond_Free(actor_diamond_t *actor)
{
    if (actor == NULL)
        return;

    Sprite_Free(actor->sprite);

    free(actor);

    actor = NULL;
}

void Actor_Diamond_Create(object_t *object, float x, float y)
{
    if (object != NULL)
    {
        actor_diamond_t *actor = (actor_diamond_t*)malloc(sizeof(actor_diamond_t));

        actor->self_object = object;

        FactoryObjects_SetActor(object, (void*)actor, AT_DIAMOND, OLAY_BONUSES);

        FactoryObjects_SetFunc(object, _Actor_Diamond_GetInfo,   OFUNC_GETINFO);
        FactoryObjects_SetFunc(object, _Actor_Diamond_Collision, OFUNC_COLLISION);
        FactoryObjects_SetFunc(object, _Actor_Diamond_Update,    OFUNC_UPDATE);
        FactoryObjects_SetFunc(object, _Actor_Diamond_Draw,      OFUNC_DRAW);
        FactoryObjects_SetFunc(object, _Actor_Diamond_Free,      OFUNC_FREE);

        actor->sprite   = Sprite_Create(Utils_GetPoint(13, 12), 27, 24, diamondTex);
        actor->position = Utils_GetVector(x, y);

        _Actor_Diamond_CreateAnimations(actor);

        Sprite_AnimationPlay(actor->sprite, "idle", true);
    }
}
